# Updates a draft sender in project

Updates a draft sender in project.

Endpoint: PATCH /v1/projects/{projectId}/kakaotalk/senders/{plusFriendId}
Version: 1.2.79
Security: BasicAuth, BearerAuth, OAuth2Production

## Path parameters:

  - `projectId` (string, required)
    The unique ID of the project. You can find this on the Sinch Dashboard.

  - `plusFriendId` (string, required)
    The unique ID of the sender.

## Request fields (application/json):

  - `status` (string)
    Create as draft or submit. Defaults to draft.
    Enum: "DRAFT", "SUBMIT"

  - `details` (object)
    Sender details and information.

  - `details.adminPhoneNo` (string)
    Admin phone

  - `details.name` (string)
    Sender name

  - `details.logoImage` (string,null)
    Sender logo

  - `details.topLevelCategoryCode` (string)
    Top level category code, must consist of 3 digits (e.g. 001).

  - `details.midLevelCategoryCode` (string)
    Mid level category code, must consist of 4 digits (e.g. 0001).

  - `details.subLevelCategoryCode` (string)
    Sub level category code, must consist of 4 digits (e.g. 0001).

## Response 200 fields (application/json):

  - `plusFriendId` (string, required)
    PlusFriend ID

  - `id` (string)
    The unique ID of the sender.

  - `state` (string)
    The current state of the sender.
    Enum: "ACTIVE", "BLOCKED", "INACTIVE", "SUSPENDED", "VERIFYING"

  - `changes` (object)
    Any pending changes to the sender.

  - `changes.status` (string, required)
    Current status of the pending changes.
    Enum: "DRAFT", "IN_PROGRESS", "REJECTED"

  - `changes.details` (array, required) — one of:
    Sender details and information.
    - KakaotalkSenderDetailsDto:
      - `adminPhoneNo` (string, required)
        Admin phone
      - `name` (string, required)
        Sender name
      - `topLevelCategoryCode` (string, required)
        Top level category code, must consist of 3 digits (e.g. 001).
      - `midLevelCategoryCode` (string, required)
        Mid level category code, must consist of 4 digits (e.g. 0001).
      - `subLevelCategoryCode` (string, required)
        Sub level category code, must consist of 4 digits (e.g. 0001).
      - `logoImage` (string)
        Sender logo
    - KakaotalkSenderChangesDetailsDto:
      - `adminPhoneNo` (string)
        Admin phone
      - `name` (string)
        Sender name
      - `logoImage` (string)
        Sender logo
      - `topLevelCategoryCode` (string)
        Top level category code, must consist of 3 digits (e.g. 001).
      - `midLevelCategoryCode` (string)
        Mid level category code, must consist of 4 digits (e.g. 0001).
      - `subLevelCategoryCode` (string)
        Sub level category code, must consist of 4 digits (e.g. 0001).

  - `details` (object)
    Sender details and information.

  - `details.adminPhoneNo` (string, required)
    Admin phone

  - `details.name` (string, required)
    Sender name

  - `details.topLevelCategoryCode` (string, required)
    Top level category code, must consist of 3 digits (e.g. 001).

  - `details.midLevelCategoryCode` (string, required)
    Mid level category code, must consist of 4 digits (e.g. 0001).

  - `details.subLevelCategoryCode` (string, required)
    Sub level category code, must consist of 4 digits (e.g. 0001).

  - `details.logoImage` (string)
    Sender logo

  - `created` (string)
    The UTC Date Time in ISO 8601 for when the sender was created.

  - `modified` (string)
    The UTC Date Time in ISO 8601 for when the sender was last modified.

## Response 400 fields (application/json):

  - `body` (FileInvalidMimeTypeErrorTitle (object) or InvalidInputErrorTitle (object) or ProjectNotInitializedErrorTitle (object) or NoFieldsToUpdateErrorTitle (object) or SenderInvalidCategoryCodeErrorTitle (object)) — one of:
    - FileInvalidMimeTypeErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "file_invalid_mime_type"
      - `message` (string)
        Human readable message.
        Example: "details.logoImage: invalid file mime type."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "Try again with supported mime types: image/jpeg, image/png."
    - InvalidInputErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "invalid_input"
      - `message` (string)
        Human readable message.
        Example: "Invalid input."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "Correct the validation errors and submit again."
      - `additionalInformation` (object)
        Additional information for error.
        Example: {"validationErrors":["Description of fields failing validation"]}
    - ProjectNotInitializedErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "project_not_initialized"
      - `message` (string)
        Human readable message.
        Example: "Project not initialized for KakaoTalk."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "Verify that the project ID is correct and that it has been onboarded for KakaoTalk."
    - NoFieldsToUpdateErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "no_fields_to_update"
      - `message` (string)
        Human readable message.
        Example: "No fields to be updated."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "Supply at least one field to be updated."
    - SenderInvalidCategoryCodeErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "sender_invalid_category_code"
      - `message` (string)
        Human readable message.
        Example: "Invalid sender category code(s)."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "Verify that the sender category code(s) used is supported."

## Response 401 fields (application/json):

  - `errorCode` (string)
    Error code allows to programmatically handle errors.
    Example: "unauthorized_error"

  - `message` (string)
    Human readable message.
    Example: "Unauthorized error."

  - `resolution` (string)
    Human readable message with an explanation of how to solve the error.
    Example: "Verify that projectId is correct."

## Response 404 fields (application/json):

  - `body` (ProjectNotFoundErrorTitle (object) or SenderNotFoundErrorTitle (object)) — one of:
    - ProjectNotFoundErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "project_not_found"
      - `message` (string)
        Human readable message.
        Example: "Project not found."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "Verify that the projectId is correct."
    - SenderNotFoundErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "sender_not_found"
      - `message` (string)
        Human readable message.
        Example: "Sender not found."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "Verify that the parameters are correct."

## Response 409 fields (application/json):

  - `body` (FileNotFoundErrorTitle (object) or FileUnexpectedErrorErrorTitle (object) or FileSizeTooLargeErrorTitle (object) or SenderChangesNotUpdatableErrorTitle (object) or SenderNotUpdatableErrorTitle (object)) — one of:
    - FileNotFoundErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "file_not_found"
      - `message` (string)
        Human readable message.
        Example: "details.logoImage: file not found."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "Verify that the url is correct."
    - FileUnexpectedErrorErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "file_unexpected_error"
      - `message` (string)
        Human readable message.
        Example: "details.logoImage: file unexpected error."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "The file cannot be handled properly. Please try with another one."
    - FileSizeTooLargeErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "file_size_too_large"
      - `message` (string)
        Human readable message.
        Example: "details.logoImage: file size is too large."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "Try again with a smaller file. Max size for `image/jpeg` is 5MB."
    - SenderChangesNotUpdatableErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "sender_changes_not_updatable"
      - `message` (string)
        Human readable message.
        Example: "Sender is not updatable."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "Updates are only supported by sender changes with status: DRAFT"
    - SenderNotUpdatableErrorTitle:
      - `errorCode` (string)
        Error code allows to programmatically handle errors.
        Example: "sender_not_updatable"
      - `message` (string)
        Human readable message.
        Example: "Sender is not updatable."
      - `resolution` (string)
        Human readable message with an explanation of how to solve the error.
        Example: "Updates are only supported by senders with state: ACTIVE."

## Response 500 fields (application/json):

  - `errorCode` (string)
    Error code allows to programmatically handle errors.
    Example: "internal_error"

  - `message` (string)
    Human readable message.
    Example: "Internal server error."

  - `resolution` (string)
    Human readable message with an explanation of how to solve the error.
    Example: "Please wait and try again, if the error persist please contact support."


